BMAP* demomap = "demo.jpg";
BMAP* floppy = "floppy1.tga";



PANEL* hud = {
	bmap=hudmap;
	pos_x=641;
	pos_y=481;
	window(470,18,151,26,health,playerhealth,hstatus);
	digits(470,48,2,*,1,ammostat1);
	digits(483,48,"|",*,0,0);
	digits(489,48,1,*,1,ammostat2);
	flags=VISIBLE;
	layer=9;
}

//big weapon for HUD
PANEL* weapon = {
	pos_x=641;
	pos_y=481;
	layer=10;
	flags=VISIBLE;
}

PANEL* objct = {
	bmap=floppy;
	pos_x=641;
	pos_y=481;
	layer=11;
	flags=VISIBLE;
}



// Demo mission definitions - these should be read from a file,
//but since we have only one demo mission, we include them in the source

//Where the player is insered
var playerposx=140; //location along the level
var playerposlevel=3; //which level

//Levels
var levels[12] = {0,365,606,440, 135,221,606,335, 135,46,606,185}; //3 levels

//Holes
var holes[8] = {2,3,257,361,1,2,556,606}; //2 holes

//Ladders
var ladders[18] = {1,1,2,548,335,104,1,2,3,250,184,151,2,2,3,362,184,151}; //3 ladders

//AI
var aiunits[22] = {300,335,335,2,2,30,30,30,30,0,0,0,0,1,0,250,313,1,0,0,0,0};


//weapons for characters
BMAP* aks = "ak49_small.tga";
BMAP* ak2 = "ak49_small_2.tga";
BMAP* akb = "ak49_big.tga";
BMAP* m4s = "m4_small.tga";
BMAP* m42 = "m4_small_2.tga";
BMAP* m4b = "m4_big.tga";

//the SpecOp's definition
BMAP* ofeet = "standing.tga";
BMAP* ofeet2 = "standing2.tga";
BMAP* obody = "body.tga";
BMAP* obody2 = "body2.tga";
BMAP* oarml = "arml.tga";
BMAP* oarmr = "armr.tga";
BMAP* oarml2 = "arml2.tga";
BMAP* oarmr2 = "armr2.tga";
BMAP* ohead = "head.tga";
BMAP* ohead2 = "head_2.tga";

BMAP* ofta01 = "moving01.tga";
BMAP* ofta02 = "moving02.tga";
BMAP* ofta03 = "moving03.tga";
BMAP* ofta04 = "moving04.tga";
BMAP* ofta11 = "moving11.tga";
BMAP* ofta12 = "moving12.tga";
BMAP* ofta13 = "moving13.tga";
BMAP* ofta14 = "moving14.tga";


BMAP* fall01 = "fall01.tga";
BMAP* fall02 = "fall02.tga";
BMAP* fall03 = "fall03.tga";
BMAP* fall04 = "fall04.tga";
BMAP* fall05 = "fall05.tga";
BMAP* fall06 = "fall06.tga";
BMAP* fall11 = "fall11.tga";
BMAP* fall12 = "fall12.tga";
BMAP* fall13 = "fall13.tga";
BMAP* fall14 = "fall14.tga";
BMAP* fall15 = "fall15.tga";
BMAP* fall16 = "fall16.tga";



PANEL* playerfeet = {bmap=ofeet; pos_x=-20; pos_y=50; layer=6; flags=VISIBLE;}
PANEL* playerbody = {bmap=obody; pos_x=-20; pos_y=30; layer=6; flags=VISIBLE;}
PANEL* playerhead = {bmap=ohead; pos_x=-20; pos_y=21; layer=6; flags=VISIBLE;}
PANEL* playergun = {bmap=m4s; pos_x=-20; pos_y=34; layer=7; flags=VISIBLE;}
PANEL* playerarml = {bmap=oarml; pos_x=-20; pos_y=31; layer=5; center_x=2; center_y=2; flags=VISIBLE;}
PANEL* playerarmr = {bmap=oarmr; pos_x=-20; pos_y=36; layer=8; center_x=2; center_y=2; flags=VISIBLE;}

//enemy
PANEL* enemy1feet = {bmap=ofeet; pos_x=-20; pos_y=50; layer=16; flags=VISIBLE;}
PANEL* enemy1body = {bmap=obody; pos_x=-20; pos_y=30; layer=16; flags=VISIBLE;}
PANEL* enemy1head= {bmap=ohead; pos_x=-20; pos_y=21; layer=16; flags=VISIBLE;}
PANEL* enemy1gun = {bmap=aks; pos_x=-20; pos_y=34; layer=17; flags=VISIBLE;}
PANEL* enemy1arml = {bmap=oarml; pos_x=-20; pos_y=31; layer=15; flags=VISIBLE;}
PANEL* enemy1armr = {bmap=oarmr; pos_x=-20; pos_y=36; layer=18; flags=VISIBLE;}



PANEL* pdeath = {pos_x=0; pos_y=0; layer=8; flags=VISIBLE;}

function playdead(){
	PANEL* pdeath = {pos_x=0; pos_y=0; layer=8; flags=VISIBLE;}
	if (mouse_pos.x+11>playerposx){
		pdeath.pos_x=playerposx-6;
		pdeath.pos_y=posy-42;
		playerposx=650;
		pdeath.bmap=fall01;
		wait(15);
		pdeath.bmap=fall02;
		wait(15);
		pdeath.bmap=fall03;
		wait(15);
		pdeath.bmap=fall04;
		wait(15);
		pdeath.bmap=fall05;
		wait(15);
		pdeath.bmap=fall06;
	} else {
		pdeath.pos_x=playerposx-6-64;
		pdeath.pos_y=posy-42;
		playerposx=650;
		pdeath.bmap=fall11;
		wait(15);
		pdeath.bmap=fall12;
		wait(15);
		pdeath.bmap=fall13;
		wait(15);
		pdeath.bmap=fall14;
		wait(15);
		pdeath.bmap=fall15;
		wait(15);
		pdeath.bmap=fall16;
	}
}






function refreshai(){
	while (ingame &&(gamepaused==0)){
		k=0;
		if ((aiunits[k*22+12]<150) && (aiunits[k*22+13]<=diff)){
			if (aiunits[k*22+10]==0){
				//find floor holes
				for (l=0; l<2; l++){
					if (holes[l*4+1]==aiunits[k*22+3]){
						if ((aiunits[k*22+0]>holes[l*4+2]) && (aiunits[k*22+0]<holes[l*4+3])){
							aiunits[k*22+3]--;
						}
					}
				}
				
				//bring the ai on the ground
				if (aiunits[k*22+1]<levels[(aiunits[k*22+3]-1)*4+3]){
					if ((aiunits[k*22+1]-aiunits[k*22+2])<1){
						aiunits[k*22+2]=aiunits[k*22+1];
					}
					aiunits[k*22+1]++;
				} else {
					if ((aiunits[k*22+1]-aiunits[k*22+2])>80){
						aiunits[k*22+12]+=pow((aiunits[k*22+1]-aiunits[k*22+2]),2)/400;
						aiunits[k*22+2]=aiunits[k*22+1];
					}
					if (aiunits[k*22+1]>levels[(aiunits[k*22+3]-1)*4+3]){
						aiunits[k*22+1]=levels[(aiunits[k*22+3]-1)*4+3];
					}
				}
				
				
				
			}
			
			// set orientation acording to sight
			if (aiunits[k*22+15]<aiunits[k*22+0]){
				aiunits[k*22+4]=2;
			} else {
				aiunits[k*22+4]=1;
			}
			
			//change the look acording to the ai's orientation
			if (aiunits[k*22+4]==1){
				enemy1feet.bmap=ofeet;
				enemy1body.bmap=obody;
				enemy1head.bmap=ohead;
				enemy1arml.bmap=oarml;
				enemy1armr.bmap=oarmr;
				enemy1arml.layer=15;
				enemy1armr.layer=18;
			} else {
				enemy1feet.bmap=ofeet2;
				enemy1body.bmap=obody2;
				enemy1head.bmap=ohead2;
				enemy1arml.bmap=oarml2;
				enemy1armr.bmap=oarmr2;
				enemy1arml.layer=18;
				enemy1armr.layer=15;
			}
				
			//stand animation
			if (aiunits[k*22+4]==1){
				enemy1feet.pos_x=aiunits[k*22+0]-7;
				enemy1arml.pos_x=aiunits[k*22+0]+2;
				enemy1armr.pos_x=aiunits[k*22+0]+2;
			} else {
				enemy1feet.pos_x=aiunits[k*22+0]-7;
				enemy1arml.pos_x=aiunits[k*22+0]-11;
				enemy1armr.pos_x=aiunits[k*22+0]-11;
			}
			enemy1feet.pos_y=aiunits[k*22+1]-22;
			enemy1arml.pos_y=aiunits[k*22+1]-31;
			enemy1armr.pos_y=aiunits[k*22+1]-31;
			
			//move ai
			enemy1body.pos_x=aiunits[k*22+0];
			enemy1body.pos_y=aiunits[k*22+1]-33;
			enemy1head.pos_x=aiunits[k*22+0]-1;
			enemy1head.pos_y=aiunits[k*22+1]-42;
			enemy1gun.pos_y=aiunits[k*22+1]-28;
			
			//rotating weapon and head
			if (aiunits[k*22+4]==1){
				enemy1gun.pos_x=aiunits[k*22+0];
				enemy1arml.pos_x=aiunits[k*22+0]+2;
				enemy1armr.pos_x=aiunits[k*22+0]+2;
				enemy1gun.center_x=0;
				enemy1gun.center_y=0;
				enemy1head.center_x=3;
				enemy1head.center_y=8;
				enemy1arml.center_x=2;
				enemy1arml.center_y=2;
				enemy1armr.center_x=2;
				enemy1armr.center_y=2;
				if (abs(aiunits[k*22+15]+11-aiunits[k*22+0])>20){
					enemy1gun.angle=atan((enemy1gun.pos_y-aiunits[k*22+16]-15)/(aiunits[k*22+15]+11-enemy1gun.pos_x));
					enemy1arml.angle=atan((enemy1gun.pos_y-aiunits[k*22+16]-15)/(aiunits[k*22+15]+11-enemy1gun.pos_x));
					enemy1armr.angle=atan((enemy1gun.pos_y-aiunits[k*22+16]-15)/(aiunits[k*22+15]+11-enemy1gun.pos_x));
					enemy1head.angle=atan((enemy1head.pos_y+8-aiunits[k*22+16]-15)/(aiunits[k*22+15]+11-enemy1head.pos_x+3));
				}
			} else {
				enemy1gun.pos_x=aiunits[k*22+0]-14;
				enemy1arml.pos_x=aiunits[k*22+0]-11;
				enemy1armr.pos_x=aiunits[k*22+0]-11;
				enemy1gun.center_x=21;
				enemy1gun.center_y=0;
				enemy1head.center_x=5;
				enemy1head.center_y=8;
				enemy1arml.center_x=16;
				enemy1arml.center_y=2;
				enemy1armr.center_x=16;
				enemy1armr.center_y=2;
				if (abs(aiunits[k*22+15]+11-aiunits[k*22+0])>20){
					enemy1gun.angle=atan((aiunits[k*22+16]+15-enemy1gun.pos_y)/(enemy1gun.pos_x-aiunits[k*22+15]+11));
					enemy1arml.angle=atan((aiunits[k*22+16]+15-enemy1gun.pos_y)/(enemy1gun.pos_x-aiunits[k*22+15]+11));
					enemy1armr.angle=atan((aiunits[k*22+16]+15-enemy1gun.pos_y)/(enemy1gun.pos_x-aiunits[k*22+15]+11));
					enemy1head.angle=atan((enemy1head.pos_y+8-aiunits[k*22+16]-15)/(aiunits[k*22+15]+11-enemy1head.pos_x+5));
				}
			}
			
			//if we know the player, kill him
			if (aiunits[k*22+14] && (playerhealth<=150) && (aiunits[k*22+3]==playerposlevel)){
				aiunits[k*22+15] = playerposx;
				aiunits[k*22+16] = posy-30;
				aiunits[k*22+21] = 1;
			} else {
				aiunits[k*22+21] = 0;
			}
			
			//scan for the player
			if ((((playerposx-aiunits[k*22+0]<0) && (aiunits[k*22+4]==2)) || ((playerposx-aiunits[k*22+0]>0) && (aiunits[k*22+4]==1)) || (abs(playerposx-aiunits[k*22+0])<100)) && (aiunits[k*22+3]==playerposlevel)){
				aiunits[k*22+14]=1;
			}
			
			//shooting handler
			if (aiunits[k*22+21]){
				if (aiunits[k*22+5+aiunits[k*22+9]]>1){
					shotbal=aiunits[k*22+0]/640*200-100;
					snd_play(ak,sndvol,shotbal);
					aiunits[k*22+5+aiunits[k*22+9]]--;
					if (random(1)>(abs(playerposx-aiunits[k*22+0])/killch)) {playerhealth+=10;}
				} else {
					if (aiunits[k*22+8]!=0){
						aiunits[k*22+9]++;
						snd_play(reloadsnd,sndvol/2,shotbal);
						wait(200);
					}
				}
			}
			
			
			
			//handle movement
			if (aiunits[k*22+11]!=0){
				if (aiunits[k*22+11]==3) {
					if (aiunits[k*22+0]>levels[(playerposlevel-1)*4+0]){aiunits[k*22+0]-=0.5;}
				} else {
					if (aiunits[k*22+0]<(levels[(playerposlevel-1)*4+2]-8)){aiunits[k*22+0]+=0.5;}
				}
			}
			
		} else {
			if (aiunits[k*22+20]!=1){
				aiunits[k*22+20]=1;
				PANEL* e1death = {pos_x=0; pos_y=0; layer=8; flags=VISIBLE;}
				if (aiunits[k*22+16]>playerposx){
					e1death.pos_x=aiunits[k*22+0]-6;
					e1death.pos_y=aiunits[k*22+1]-42;
					enemy1body.pos_x = 650;
					enemy1feet.pos_x = 650;
					enemy1head.pos_x = 650;
					enemy1arml.pos_x = 650;
					enemy1armr.pos_x = 650;
					enemy1gun.pos_x = 650;
					e1death.bmap=fall01;
					wait(15);
					e1death.bmap=fall02;
					wait(15);
					e1death.bmap=fall03;
					wait(15);
					e1death.bmap=fall04;
					wait(15);
					e1death.bmap=fall05;
					wait(15);
					e1death.bmap=fall06;
				} else {
					e1death.pos_x=aiunits[k*22+0]-6-64;
					e1death.pos_y=aiunits[k*22+1]-42;
					enemy1body.pos_x = 650;
					enemy1feet.pos_x = 650;
					enemy1head.pos_x = 650;
					enemy1arml.pos_x = 650;
					enemy1armr.pos_x = 650;
					enemy1gun.pos_x = 650;
					e1death.bmap=fall11;
					wait(15);
					e1death.bmap=fall12;
					wait(15);
					e1death.bmap=fall13;
					wait(15);
					e1death.bmap=fall14;
					wait(15);
					e1death.bmap=fall15;
					wait(15);
					e1death.bmap=fall16;
				}
			}
		}
		
		
		
		wait(20);
	}
}


PANEL* demo = {bmap=demomap; pos_x=0; pos_y=0;}

function refresh(){beep();}  // fake


//preparing the game
function prepare(){
	if (musichnd!=0) {fademusic();}
	mouse_map=targetc;
	hideng2();
	hidebi();
	set(demo,VISIBLE);
	demo.pos_x=0;
	demo.pos_y=0;
	demo.layer=6;
	hud.pos_x=0;
	hud.pos_y=0;
	weapon.pos_x=0;
	weapon.pos_y=0;
	objct.pos_x=550;
	objct.pos_y=130;
	ingame=1;
	gamepaused=0;
	shotbal=0;
	//tmpx=0;
	hmanim=0;
	porient=1;
	playergunmodel=1; 
	playerammo[0]=30;
	playerammo[1]=30;
	playerammo[2]=30;
	playerammo[3]=30;
	playercurrentmag=0;
	playerhealth=0;
	hstatus=0;
	magcur=0;
	playerposx=50;
	playerposlevel=1;
	posy=440;
	objdone=0;
	aiunits=tempai;
	switch (diff){
		case 1:
		killch=200; break;
		case 2:
		killch=400; break;
		case 3:
		killch=600; break;
	}
}


// handle the ESC key
function pause()
{if ((ingame==1) && (inopt==0) && (pgshown==1))
{
	if (gamepaused==0)
	{
		gamepaused=1;
		mouse_map=cur;
		showpg();
	}
	else
	{
		hidepg();
		mouse_map=targetc;
		gamepaused=0;
		refresh();
	}
}
else {
	if (pgshown==1) {
		if (opshown==1) {
		if (inopt==1) {if (opshown){hideop();}}
			else {
			if (inmain==0) {if (ngshown){hideng();}}
				else {sys_exit(NULL);}
				
			}
		}
	}
}
}


//closes the game
function endmission(){
	mouse_map=cur;
	showng2();
	showbi();
	set(demo,INVISIBLE);
	set(pg,INVISIBLE);
	pg.pos_x=641;
	pg.pos_y=481;
	demo.pos_x=641;
	demo.pos_y=481;
	demo.layer=0;
	hud.pos_x=641;
	hud.pos_y=481;
	weapon.pos_x=641;
	weapon.pos_y=481;
	objct.pos_x=641;
	objct.pos_y=481;
	if (musichnd==0)	{musichnd=media_loop("iron-man.mp3",NULL,100);}
	gamepaused=0;
	ingame=0;
	on_esc = pause;
	hidelost();
	hidewon();
	pdeath.pos_x=645;
}



function magnum(){
	magcur=0;
	magcount=4;
	while(magcur<4){
		if(playerammo[magcur]<=0){
			magcount--;
		}
		magcur++;
		if (magcur==4){
			return (magcount);
		}
	}
}


function animplmove(){
	while((key_a || key_d) && ingame && (gamepaused==0)){
		if(porient==1){
			switch (animph){
				case 1:playerfeet.bmap=ofta01;
				case 2:playerfeet.bmap=ofta02;
				case 3:playerfeet.bmap=ofta03;
				case 4:playerfeet.bmap=ofta04;
			}
			if(key_d){
				if (animph<4){
					animph++;
				} else {
					animph=1;
				}
			} else {
				if (animph>1){
					animph--;
				} else {
					animph=4;
				}
			}
		} else {
			switch (animph){
				case 1:playerfeet.bmap=ofta11;
				case 2:playerfeet.bmap=ofta12;
				case 3:playerfeet.bmap=ofta13;
				case 4:playerfeet.bmap=ofta14;
			}
			if(key_d){
				if (animph>1){
					animph--;
				} else {
					animph=4;
				}
			} else {
				if (animph<4){
					animph++;
				} else {
					animph=1;
				}
			}
		}
		wait(10);
	}
}



//refreshing player position

function refresh(){
	while(ingame && (gamepaused==0)){
		if (onladder==0){
			//find floor holes
			for (j=0; j<2; j++){
				if (holes[j*4+1]==playerposlevel){
					if ((playerposx>holes[j*4+2]) && (playerposx<holes[j*4+3])){
						playerposlevel--;
					}
				}
			}
			
			//bring the player on the ground
			if (posy<levels[(playerposlevel-1)*4+3]){
				if ((posy-falling)<1){
					falling=posy;
				}
				posy++;
			} else {
				if ((posy-falling)>80){
					playerhealth+=pow((posy-falling),2)/400;
					falling=posy;
				}
				if (posy>levels[(playerposlevel-1)*4+3]){
					posy=levels[(playerposlevel-1)*4+3];
				}
			}
		}
		
		//check if the weapon is loaded
		if (snd_playing(rldsnd)==0) {canshoot=1;}
		
		//update ammo status
		ammostat1=playerammo[playercurrentmag];
		if (ammostat1<=0){
			ammostat2=magnum();
		} else {
			ammostat2=magnum()-1;
		}
		
		// show weapon image in HUD
		if (playergunmodel==1){
			weapon.bmap=m4b;
		} else {
			weapon.bmap=akb;
		}
		
		
		// make health bar chnage color
		if (playerhealth<120){
			if (playerhealth<60){
				hstatus=0;
			} else {
				hstatus=28;
			}
		} else {
			hstatus=60;
		}
		
		// if you die
		if (playerhealth>150){
			on_esc = endmission;
			ingame=0;
			playdead();
			showlost();
		}
		
		// if you take the floppy
		if ((playerposlevel==3) && (playerposx>540)){
			objdone=1;
			objct.pos_x=641;
		}
		
		//if you have the floppy and you're heading home
		if (objdone && (playerposlevel==1) && (playerposx<50)){
			on_esc = endmission;
			ingame=0;
			showwon();
		}
		
		// change player look acording to its direction and weapon
		if (mouse_pos.x+11>playerposx){
			if (!(key_a || key_d)){playerfeet.bmap=ofeet;}
			playerbody.bmap=obody;
			playerhead.bmap=ohead;
			playerarml.bmap=oarml;
			playerarmr.bmap=oarmr;
			playerarml.layer=5;
			playerarmr.layer=8;
			if (playergunmodel==1){
				playergun.bmap=m4s;
			} else {
				playergun.bmap=aks;
			}
			porient=1;
		} else {
			if (!(key_a || key_d)){playerfeet.bmap=ofeet2;}
			playerbody.bmap=obody2;
			playerhead.bmap=ohead2;
			playerarml.bmap=oarml2;
			playerarmr.bmap=oarmr2;
			playerarml.layer=8;
			playerarmr.layer=5;
			if (playergunmodel==1){
				playergun.bmap=m42;
			} else {
				playergun.bmap=ak2;
			}
			porient=2;
		}
		
		//stand animation
		if (porient==1){
			playerfeet.pos_x=playerposx-7;
			playerarml.pos_x=playerposx+2;
			playerarmr.pos_x=playerposx+2;
		} else {
			playerfeet.pos_x=playerposx-7;
			playerarml.pos_x=playerposx-11;
			playerarmr.pos_x=playerposx-11;
		}
		playerfeet.pos_y=posy-22;
		playerarml.pos_y=posy-31;
		playerarmr.pos_y=posy-31;
		
		//move player
		playerbody.pos_x=playerposx;
		playerbody.pos_y=posy-33;
		playerhead.pos_x=playerposx-1;
		playerhead.pos_y=posy-42;
		playergun.pos_y=posy-28;
		
		//rotating weapon and head
		if (porient==1){
			playergun.pos_x=playerposx;
			playerarml.pos_x=playerposx+2;
			playerarmr.pos_x=playerposx+2;
			playergun.center_x=0;
			playergun.center_y=0;
			playerhead.center_x=3;
			playerhead.center_y=8;
			playerarml.center_x=2;
			playerarml.center_y=2;
			playerarmr.center_x=2;
			playerarmr.center_y=2;
			if (abs(mouse_pos.x+11-playerposx)>20){
				playergun.angle=atan((playergun.pos_y-mouse_pos.y-15)/(mouse_pos.x+11-playergun.pos_x));
				playerarml.angle=atan((playergun.pos_y-mouse_pos.y-15)/(mouse_pos.x+11-playergun.pos_x));
				playerarmr.angle=atan((playergun.pos_y-mouse_pos.y-15)/(mouse_pos.x+11-playergun.pos_x));
				playerhead.angle=atan((playerhead.pos_y+8-mouse_pos.y-15)/(mouse_pos.x+11-playerhead.pos_x+3));
			}
		} else {
			playergun.pos_x=playerposx-14;
			playerarml.pos_x=playerposx-11;
			playerarmr.pos_x=playerposx-11;
			playergun.center_x=21;
			playergun.center_y=0;
			playerhead.center_x=5;
			playerhead.center_y=8;
			playerarml.center_x=16;
			playerarml.center_y=2;
			playerarmr.center_x=16;
			playerarmr.center_y=2;
			if (abs(mouse_pos.x+11-playerposx)>20){
				playergun.angle=atan((mouse_pos.y+15-playergun.pos_y)/(playergun.pos_x-mouse_pos.x+11));
				playerarml.angle=atan((mouse_pos.y+15-playergun.pos_y)/(playergun.pos_x-mouse_pos.x+11));
				playerarmr.angle=atan((mouse_pos.y+15-playergun.pos_y)/(playergun.pos_x-mouse_pos.x+11));
				playerhead.angle=atan((playerhead.pos_y+8-mouse_pos.y-15)/(mouse_pos.x+11-playerhead.pos_x+5));
			}
		}
		
		wait(1);
	}
	
}




// climb ladders up
function goup() {
	if (onladder==0){
		i=0;
		while (((ladders[i*6+1]!=playerposlevel) || (abs(playerposx-ladders[i*6+3])>14)) && i<3){
			i++;
		}
		if (ladders[i*6+1]==playerposlevel){
			if (abs(playerposx-ladders[i*6+3])<15){
				onladder=1; intonladder=1;
				playerposx=ladders[i*6+3];
				while(key_w && posy>=ladders[i*6+4]){
					posy-=0.1;
					wait(time_step);
				}
				if (posy<=ladders[i*6+4]){
					if (ladders[i*6]==1){
						playerposx=playerposx-14;
					} else {
						playerposx=playerposx+14;
					}
					if ((playerposlevel<3) && (intonladder==1)){playerposlevel++;}
					onladder=0; intonladder=0;
				}
			}
		}
	} else {
		while(key_w && posy>=ladders[i*6+4]){
			posy-=0.1;
			wait(time_step);
		}
		if (posy<=ladders[i*6+4]){
			if (ladders[i*6]==1){
				playerposx=playerposx-14;
			} else {
				playerposx=playerposx+14;
			}
			if ((playerposlevel<3) && (intonladder==1)){playerposlevel++;}
			onladder=0;
		}
	}
}


// climb ladders down
function godown() {
	if (onladder==0){
		i=0;
		while (((ladders[i*6+2]!=playerposlevel) || (abs(playerposx-ladders[i*6+3])>14)) && i<3){
			i++;
		}
		if (ladders[i*6+2]==playerposlevel){
			if (abs(playerposx-ladders[i*6+3])<15){
				onladder=1; intonladder=2;
				playerposx=ladders[i*6+3];
				while(key_s && posy<=(ladders[i*6+4]+ladders[i*6+5])){
					posy+=0.1;
					falling=posy;
					wait(time_step);
				}
				if (posy>=(ladders[i*6+4]+ladders[i*6+5])){
					if ((playerposlevel>1) && (intonladder==2)){playerposlevel--;}
					onladder=0; intonladder=0;
				}
			}
		}
	} else {
		while(key_s && posy<=(ladders[i*6+4]+ladders[i*6+5])){
			posy+=0.1;
			falling=posy;
			wait(time_step);
		}
		if (posy>=(ladders[i*6+4]+ladders[i*6+5])){
			if ((playerposlevel>1) && (intonladder==2)){playerposlevel--;}
			onladder=0;
		}
	}
}


//function lgl(){
//	playerlegr.center_x=3;
//	playerlegr.center_y=1;
//	playerlegr.angle -= 10;
//	playerfootr.pos_x -= playerlegr.pos_x-1;
//	playerfootr.pos_y -= playerlegr.pos_y;
//	tmpx=playerfootr.pos_x;
//	playerfootr.pos_x = playerfootr.pos_x*(0.984807)-playerfootr.pos_y*0.173648;
//	playerfootr.pos_y = tmpx*0.173648+playerfootr.pos_y*(0.984807);
//	playerfootr.pos_x += playerlegr.pos_x-1;
//	playerfootr.pos_y += playerlegr.pos_y;
//}



//functions for moving the player
function pml(){
	animplmove();
	while (key_a && (onladder==0)){
		if (playerposx>levels[(playerposlevel-1)*4+0]){
			playerposx-=0.3;hmanim=1;
			} else {
				hmanim=0;
			}
		wait(time_step);
	}
}
function pmr(){
	animplmove();
	while(key_d && (onladder==0)){
		if (playerposx<(levels[(playerposlevel-1)*4+2]-8)){
			playerposx+=0.3;hmanim=2;
			} else {
				hmanim=0;
			}
		wait(time_step);
	}
}





//shooting main weapon
function shoot(){
	if (ingame==1 && canshoot==1){
		if (gamepaused==0){
			shotbal=playerposx/640*200-100;
			if (playerammo[playercurrentmag]>0){
				while(mouse_left && (playerammo[playercurrentmag]>0)){
					if (playergunmodel==1){
						snd_play(m4,sndvol/10,shotbal);
						playerammo[playercurrentmag]--;
					} else {
						snd_play(ak,sndvol,shotbal);
						playerammo[playercurrentmag]--;
					}
					for (m=0; m<=0; m++){
						if ((abs(mouse_pos.x+11-aiunits[m*22+0])<10) && (abs(mouse_pos.y+11-aiunits[m*22+1]-22)<84)){
							if (random(1)>(abs(playerposx-aiunits[m*22+0])/(1000-killch))) {
								aiunits[m*22+12]+=20;
								aiunits[m*22+14]=1;
							}
						}
					}
					wait(30);
				}
			} else {
				snd_play(empty,sndvol/2,shotbal);
			}
		}
	}
}


//reloading weapon
function reload(){
	if (magnum()>0) {
		static var oldmag=playercurrentmag;
		if (playercurrentmag==3) {
			playercurrentmag=0;
		} else {
			playercurrentmag++;
		}
		while(playerammo[playercurrentmag]<=0){
			if (playercurrentmag==3) {
				playercurrentmag=0;
			} else {
				playercurrentmag++;
			}
			wait(1);
		}
		if (oldmag!=playercurrentmag){
			shotbal=playerposx/640*200-100;
			canshoot=0;
			rldsnd=snd_play(reloadsnd,sndvol/2,shotbal);	
		}
	}
}

// this function must be changed - DON'T FORGET
function chweapon(){
	if (playergunmodel==1) {
		playergunmodel=2;
	} else {
		playergunmodel=1;
	}
}

// start the game
function startdemo(){
if (ngshown){
	prepare();
//	initsoldier(1);
	hidelost();
	hidewon();
	on_mouse_left = shoot;
	on_mouse_right = reload;
	on_esc = pause;
	refresh();
	refreshai();
	on_space = chweapon;
	on_a = pml;
	on_d = pmr;
	on_w = goup;
	on_s = godown;
}
}