///////////////////////////////
#include <acknex.h>
#include <default.c>
#include <definitions.c>
#include <menus.c>
///////////////////////////////


//fades out the music when a mission is loaded
function fademusic(){
	while(midi_vol>0){
		midi_vol=midi_vol-1;
		wait(5);
	}
	media_stop(musichnd);
	musichnd=0;
}

PANEL* splashs = {bmap="is_logo.jpg"; layer=0;}

PANEL* bgimg = {bmap="is_background.jpg"; layer=0;}

function tic(){snd_play(ticsound,sndvol/2,0);}

// show the options screen
function showop() {
if (mainshown){
	if (ingame==0) {
		hidemain();
		} else {
		hidepg2();
	} 
	opshown=0;
	wait(200);
	showopt();
	inopt=1;
}
}

// hides the options screen
function hideop() {
	hideopt();
	wait(200);
	if (ingame==0){
		reshowmain();
		} else {
		reshowpg();
	}
	inopt=0;
}

// show the new game screen
function showng() {
if (mainshown){
	hidemain();
	ngshown=0;
	wait(200);
	showngs();
}
}

// hides newgame screen
function hideng() {
if (ngshown){
	hidengs();
	wait(200);
	reshowmain();
}
}

function showbi() {set(bgimg,VISIBLE); bgimg.pos_x=0; bgimg.pos_y=0;}
function hidebi() {set(bgimg,INVISIBLE); bgimg.pos_x=641; bgimg.pos_y=481;}

//now we can define mission functions
#include <mission.c>

// functions for changing difficulty
function makeiteasy() {diff=1;}
function makeitnormal() {diff=2;}
function makeithard() {diff=3;}

function gamexit() {sys_exit("");} // exits the game

function main () {
	// this is the handle of the reload sound, but I use it here to have it prepared for the mission when it will be scanned
	rldsnd=snd_play(ticsound,1,0);
	on_esc=pause;
	level_load("");
	wait(3); //wait for the level to load
	set(splashs,VISIBLE); //show the splash screen
	wait(500); //wait some time
	set(bgimg,VISIBLE);
	wait(5);
	pan_remove(splashs);
	mouse_map=cur;
	mouse_mode=4;
	musichnd=media_loop("iron-man.mp3",NULL,100);
	showmain();
	wait(3);
	button_state(poptions,2,ON);
	while(1) {if (ingame==0) {
		midi_vol=musicvol;}wait(10);}
}